.NET
cancel
Showing results for 
Show  only  | Search instead for 
Did you mean: 

X-Ref Listing with RealDwg

1 REPLY 1
Reply
Message 1 of 2
shunta17
809 Views, 1 Reply

X-Ref Listing with RealDwg

Is it possible to get a listing of all of the X-Refs contained in a particular document. I am attempting to do this with the following code: db.ReadDwgFile(testFileName, FileOpenMode.OpenForReadAndWriteNoShare, true, null); using (var tx = db.TransactionManager.StartTransaction()) { var xrefGraph = db.GetHostDwgXrefGraph(true); for(int i = 0; i < xrefGraph.NumNodes; i++) { XrefGraphNode xgn = xrefGraph.GetXrefNode(i); Console.WriteLine(xgn.Name); } } I know that this drawing has 3 attached X-Refs, but none are coming up in the node graph. Any ideas of what I may be doing wrong? Thanks and Regards, Sean Hunter
Tags (2)
1 REPLY 1
Message 2 of 2
philippe.leefsma
in reply to: shunta17

Hi,

 

XRefs are accessed in RealDWG the exact same way than in AutoCAD. You first need to call "Database.ResolveXrefs" and of course to have those referenced documents physically present on your disk. They won't get resolved otherwise...

 

Here is an AutoCAD command. RealDWG code will be the same, except you don't have Document, Editor and you get the database using HostApplicationServices.WorkingDatabase:

 

[CommandMethod("XrefGraph")]
public static void XrefGraph()
{
    Document doc = Application.DocumentManager.MdiActiveDocument;
    Database db = doc.Database;
    Editor ed = doc.Editor;

    using (Transaction Tx = db.TransactionManager.StartTransaction())
    {
        db.ResolveXrefs(true, false);

        XrefGraph xg = db.GetHostDwgXrefGraph(true);

        for (int i = 1; i < xg.NumNodes; ++i)
        {
            XrefGraphNode node = xg.GetXrefNode(i);

            if (node.XrefStatus == XrefStatus.Resolved)
            {
                BlockTableRecord btr = Tx.GetObject(node.BlockTableRecordId, OpenMode.ForRead) as BlockTableRecord;

                ed.WriteMessage("\n---------------------");

                if (btr.IsFromExternalReference == true)
                {
                    ed.WriteMessage("\nXref path name: " + btr.PathName);
                } 

                ed.WriteMessage("\nName of Xref (Found name): " + node.Database.Filename);
            }
        }
    }
}

 

 

Philippe Leefsma
Developer Consultant
Developer Technical Services
Global Subscription & Support

 

www.autodesk.com/joinadn



Philippe Leefsma
Developer Technical Services
Autodesk Developer Network

Can't find what you're looking for? Ask the community or share your knowledge.

Post to forums  

Autodesk DevCon in Munich May 28-29th


Autodesk Design & Make Report

”Boost